#include <stdio.h>
#include <stdarg.h>
#include <ctype.h>
#include <process.h>
#include <string.h>
#include <time.h>
#include <stdlib.h>
#include <conio.h>
#include <errno.h>
#include <fcntl.h>
#include <io.h>
#include <dos.h>
#include <share.h>
#include <dir.h>
#include <alloc.h>
#include <sys\stat.h>
#include <math.h>
extern "C" {
#include "tcp.h"
}

#include "net.h"
#include "vardec.h"
#include "version.h"
#include "retcode.h"

extern unsigned _stklen = 10000U;

#define SHARE_LEVEL 10
#define WAIT_TIME 10
#define TRIES 100

#define MT_DESQVIEW 0x01
#define MT_WINDOWS  0x02
#define MT_OS2      0x04
#define MT_NB       0x40

#define BIGSTR 2048
#define STRING 513
#define STR 129
#define WAIT_TIME 10
#define TRIES 100
#define NUL '\0'
#define LAST(s) s[strlen(s)-1]
#define NNTP_PORT 119
#define MAX_LOG 800

#define free_Mail_Socket(SOCK) if (SOCK!=NULL) {     \
  farfree(SOCK->sock); farfree(SOCK); SOCK=NULL; }

typedef struct {
  tcp_Socket *sock;
} Mail_Socket;

configrec syscfg;

char *version = "Freeware PPP Project News Retrieval " VERSION;

static char _temp_buffer[STRING];
char POPNAME[60], POPDOMAIN[60];
char cur_path[STRING], cur_from[STRING], cur_subject[STRING], cur_replyto[STRING];
char cur_newsgroups[STRING], cur_message_ID[STRING], cur_organization[STRING];
char cur_articleid[STRING], cur_references[STRING], cur_lines[STR], cur_date[STRING];
char maindir[MAXPATH], serverhost[40], net_data[181];
int instance, crossposts, binxpost, multitasker = 0, spooltodisk = 0;;
static int NNTP_stat;
unsigned long cur_daten, reparticle, cur_numa, cur_first, cur_last;
unsigned short reply, sy;
static char NEWSNAME[STRING], NEWSPASS[STRING];

typedef struct {
  char groupname[60];
  unsigned long lastread;
  char subtype[8];
} GROUPFILEREC;

GROUPFILEREC *grouprec;
int ngroups;

#define SOCK_READ_ERR(PROTOCOL) sock_err:                                 \
  switch (PROTOCOL##_stat) {                                              \
    case 1 :                                                              \
      fprintf(stderr, "\n ! Session error : %s\n",                        \
          sockerr(PROTOCOL##_sock->sock));                                \
      fcloseall();                                                        \
      free_Mail_Socket(PROTOCOL##_sock);                                  \
      cursor('R');                                                        \
      exit(EXIT_FAILURE);                                                 \
    case -1:                                                              \
      fprintf(stderr, "\n ! Timeout : %s\n",                              \
          sockerr(PROTOCOL##_sock->sock));                                \
      fcloseall();                                                        \
      free_Mail_Socket(PROTOCOL##_sock);                                  \
      cursor('R');                                                        \
      exit(EXIT_FAILURE);                                                 \
  }                                                                       \

char *texth[] = {"th", "st", "nd", "rd"};

char *ordinal_text(int number)
{
  if (((number %= 100) > 9 && number < 20) || (number %= 10) > 3)
    number = 0;
  return texth[number];
}

static unsigned cursize;

void cursor(int tmp)
{
  union REGS inregs, outregs;

  switch (toupper(tmp)) {
    case 'S':                               /* Save */
      inregs.h.ah = 3;
      inregs.h.bh = 0;
      int86(0x10, &inregs, &outregs);
      cursize = outregs.x.cx;
      break;
    case 'R':                               /* Restore */
      inregs.h.ah = 1;
      inregs.x.cx = cursize;
      int86(0x10, &inregs, &outregs);
      break;
    case 'H':                               /* Hide */
      inregs.h.ah = 1;
      inregs.h.ch = 0x20;
      int86(0x10, &inregs, &outregs);
      break;
    case 'N':                               /* Normal */
      inregs.h.ah = 1;
      inregs.h.ch = 6;
      inregs.h.cl = 7;
      int86(0x10, &inregs, &outregs);
      break;
  }
}

void dv_pause(void)
{
  __emit__(0xb8, 0x1a, 0x10, 0xcd, 0x15);
  __emit__(0xb8, 0x00, 0x10, 0xcd, 0x15);
  __emit__(0xb8, 0x25, 0x10, 0xcd, 0x15);
}

void win_pause(void)
{
  __emit__(0x55, 0xb8, 0x80, 0x16, 0xcd, 0x2f, 0x5d);
}

int get_dos_version(void)
{
  _AX = 0x3000;
  geninterrupt(0x21);
  if (_AX % 256 >= 10) {
    multitasker |= MT_OS2;
  }
  return (_AX);
}

int get_dv_version(void)
{
  int v;

  if (multitasker & MT_OS2)
    return 0;
  _AX = 0x2b01;
  _CX = 0x4445;
  _DX = 0x5351;
  geninterrupt(0x21);
  if (_AL == 0xff) {
    return 0;
  } else {
    v = _BX;
    multitasker |= MT_DESQVIEW;
    return v;
  }
}

int get_win_version(void)
{
  int v = 0;

  __emit__(0x55, 0x06, 0x53);
  _AX = 0x352f;
  geninterrupt(0x21);
  _AX = _ES;
  if (_AX | _BX) {
    _AX = 0x1600;
    geninterrupt(0x2f);
    v = _AX;
    if (v % 256 <= 1)
      v = 0;
  }
  __emit__(0x5b, 0x07, 0x5d);
  if (v != 0)
    multitasker |= MT_WINDOWS;
  return (v);
}

int get_nb_version(void)
{
  _AX = 0;
  geninterrupt(0x2A);
  return (_AH);
}

void detect_multitask(void)
{
  get_dos_version();
  get_win_version();
  get_dv_version();
  if (multitasker < 2)
    if (get_nb_version())
      multitasker = MT_NB;
}

void giveup_timeslice(void)
{
  if (multitasker) {
    switch (multitasker) {
 case 1: 
 case 3: 
        dv_pause();
        break;
      case 2:
      case 4:
      case 5:
      case 6:
      case 7:
        win_pause();
        break;
      default:
        break;
    }
  }
}

void output(char *fmt,...)
{
  va_list v;
  char s[255];

  va_start(v, fmt);
  vsprintf(s, fmt, v);
  va_end(v);
  fputs(s, stderr);
}

void backline(void)
{
  int i;

  output(" ");
  for (i = wherex(); i > 0; i--)
    output("\b \b");
}

void cd_to(char *s)
{
  char *s1;
  int i, db;

  s1 = s;
  i = strlen(s1) - 1;
  db = (s1[i] == '\\');
  if (i == 0)
    db = 0;
  if ((i == 2) && (s1[1] == ':'))
    db = 0;
  if (db)
    s1[i] = 0;
  chdir(s1);
  if (s[1] == ':')
    setdisk(s[0] - 'A');
}

void get_dir(char *s, int be)
{
  strcpy(s, "X:\\");
  s[0] = 'A' + getdisk();
  getcurdir(0, s + 3);
  if (be) {
    if (s[strlen(s) - 1] != '\\')
      strcat(s, "\\");
  }
}

int sh_write(int handle, void *buffer, unsigned long len)
{
  if (handle == -1) {
    return (-1);
  }
  return (write(handle, buffer, (unsigned) len));
}

int sh_open(char *path, int file_access, unsigned fmode)
{
  int handle, count, share;
  char drive[MAXDRIVE], dir[MAXDIR], file[MAXFILE], ext[MAXEXT];

  if ((file_access & O_RDWR) || (file_access & O_WRONLY) || (fmode & S_IWRITE)) {
    share = SH_DENYRW;
  } else {
    share = SH_DENYWR;
  }
  handle = open(path, file_access | share, fmode);
  if (handle < 0) {
    count = 1;
    fnsplit(path, drive, dir, file, ext);
    if (access(path, 0) != -1) {
      delay(WAIT_TIME);
      handle = open(path, file_access | share, fmode);
      while (((handle < 0) && (errno == EACCES)) && (count < TRIES)) {
        if (count % 2)
          delay(WAIT_TIME);
        else
          giveup_timeslice();
        count++;
        handle = open(path, file_access | share, fmode);
      }
    }
  }
  return (handle);
}

int sh_open1(char *path, int access)
{
  unsigned fmode;

  fmode = 0;
  if ((access & O_RDWR) || (access & O_WRONLY))
    fmode |= S_IWRITE;
  if ((access & O_RDWR) || (access & O_RDONLY))
    fmode |= S_IREAD;
  return (sh_open(path, access, fmode));
}

int sh_close(int f)
{
  if (f != -1)
    close(f);
  return (-1);
}

int sh_read(int handle, void *buf, unsigned len)
{
  if (handle == -1) {
    return (-1);
  }
  return (read(handle, buf, len));
}

long sh_lseek(int handle, long offset, int fromwhere)
{
  if (handle == -1) {
    return (-1L);
  }
  return (lseek(handle, offset, fromwhere));
}

FILE *fsh_open(char *path, char *fmode)
{
  FILE *f;
  int count, share, md, fd;
  char drive[MAXDRIVE], dir[MAXDIR], file[MAXFILE], ext[MAXEXT];

  share = SH_DENYWR;
  md = 0;
  if (((char *) strchr(fmode, 'w')) != NULL) {
    share = SH_DENYRD;
    md = O_RDWR | O_CREAT | O_TRUNC;
  } else
    if (((char *) strchr(fmode, 'a')) != NULL) {
    share = SH_DENYRD;
    md = O_RDWR | O_CREAT;
  } else {
    md = O_RDONLY;
  }
  if (((char *) strchr(fmode, 'b')) != NULL) {
    md |= O_BINARY;
  }
  if (((char *) strchr(fmode, '+')) != NULL) {
    md &= ~O_RDONLY;
    md |= O_RDWR;
    share = SH_DENYRD;
  }
  fd = open(path, md | share, S_IREAD | S_IWRITE);
  if (fd < 0) {
    count = 1;
    fnsplit(path, drive, dir, file, ext);
    if ((access(path, 0)) != -1) {
      delay(WAIT_TIME);
      fd = open(path, md | share, S_IREAD | S_IWRITE);
      while (((fd < 0) && (errno == EACCES)) && (count < TRIES)) {
        delay(WAIT_TIME);
        count++;
        fd = open(path, md | share, S_IREAD | S_IWRITE);
      }
    }
  }
  if (fd > 0) {
    if (((char *) strchr(fmode, 'a')) != NULL)
      sh_lseek(fd, 0L, SEEK_END);
    f = fdopen(fd, fmode);
    if (!f) {
      close(fd);
    }
  } else
    f = 0;
  return (f);
}

size_t fsh_write(void *ptr, size_t size, size_t n, FILE * stream)
{

  if (stream == NULL) {
    return (0);
  }
  return (fwrite(ptr, size, n, stream));
}

void trim_log(void)
{
  int num_lines, total_lines, kill_lines;
  FILE *old_log, *new_log;
  char ol[101], nl[101], s[121];

  sprintf(ol, "%sNEWS.LOG", net_data);
  sprintf(nl, "%sNEWS.ZZZ", net_data);

  old_log = fopen(ol, "r");
  new_log = fopen(nl, "a");

  total_lines = 0;
  if (old_log != NULL) {
    while (!(fgets(s, 100, old_log) == NULL))
      ++total_lines;
    rewind(old_log);
    if (total_lines < MAX_LOG) {
      fclose(old_log);
      if (new_log != NULL)
        fclose(new_log);
      unlink(nl);
      return;
    }
    kill_lines = total_lines - MAX_LOG;
    num_lines = 0;
    while ((fgets(s, 80, old_log)) && (num_lines < kill_lines))
      num_lines++;
    while ((strstr(s, "NEWS session") == NULL) && (num_lines < total_lines)) {
      fgets(s, 80, old_log);
      num_lines++;
    }
    fputs(s, new_log);
    while ((!(fgets(s, 80, old_log) == NULL)))
      fputs(s, new_log);
  }
  if (old_log != NULL)
    fclose(old_log);
  if (new_log != NULL)
    fclose(new_log);
  unlink(ol);
  rename(nl, ol);
}

void ssm(char *s)
{
  int f, i, i1;
  char s1[161];
  shortmsgrec sm;
  configrec syscfg;

  sprintf(s1, "CONFIG.DAT");
  f = sh_open1(s1, O_RDONLY | O_BINARY);
  if (f < 0)
    return;
  sh_read(f, (void *) (&syscfg), sizeof(configrec));
  f = sh_close(f);
  sprintf(s1, "%sSMW.DAT", syscfg.datadir);
  f = sh_open(s1, O_RDWR | O_BINARY | O_CREAT, S_IREAD | S_IWRITE);
  if (f < 0)
    return;
  i = (int) (filelength(f) / sizeof(shortmsgrec));
  i1 = i - 1;
  if (i1 >= 0) {
    sh_lseek(f, ((long) (i1)) * sizeof(shortmsgrec), SEEK_SET);
    sh_read(f, (void *) &sm, sizeof(shortmsgrec));
    while ((sm.tosys == 0) && (sm.touser == 0) && (i1 > 0)) {
      --i1;
      sh_lseek(f, ((long) (i1)) * sizeof(shortmsgrec), SEEK_SET);
      sh_read(f, (void *) &sm, sizeof(shortmsgrec));
    }
    if ((sm.tosys) || (sm.touser))
      ++i1;
  } else
    i1 = 0;
  sm.tosys = 0;
  sm.touser = 1;
  strncpy(sm.message, s, 80);
  sm.message[80] = 0;
  sh_lseek(f, ((long) (i1)) * sizeof(shortmsgrec), SEEK_SET);
  sh_write(f, (void *) &sm, sizeof(shortmsgrec));
  f = sh_close(f);
}

unsigned char *trimstr1(unsigned char *s)
{
  int i;
  static char *whitespace = " \r\n\t";

  i = strlen(s);
  while ((i > 0) && (strchr(whitespace, s[i - 1])))
    --i;
  while ((i > 0) && (strchr(whitespace, *s))) {
    memmove(s, s + 1, --i);
  }
  s[i] = 0;
  return (s);
}



int log_it(int send_ssm, char *fmt,...)
{
  va_list v;
  char s[255], fn[MAXPATH];
  FILE *fp;

  sprintf(fn, "%sNEWS.LOG", net_data);
  if ((fp = fsh_open(fn, "at")) == NULL)
    return 1;
  va_start(v, fmt);
  vsprintf(s, fmt, v);
  va_end(v);
  fputs(s, fp);
  fputs(s, stderr);
  if (fp != NULL)
    fclose(fp);
  trimstr1(s);
  if (send_ssm)
    ssm(s);
  return 0;
}


int count_lines(char *s)
{
  FILE *fp;
  char fn[201];
  unsigned int nl = 0;
  const int NEWLINE = '\n';
  int c;

  strcpy(fn, s);
  if ((fp = fsh_open(fn, "rt")) == NULL) {
    output("\n  Cannot open %s", fn);
    return 0;
  }
  while ((c = getc(fp)) != EOF) {
    if (c == NEWLINE)
      ++nl;
  }
  if (fp != NULL)
    fclose(fp);
  return nl;
}

int exist(char *s)
{
  int i;
  struct ffblk ff;

  i = findfirst(s, &ff, 0);
  if (i)
    return (0);
  else
    return (1);
}

void rename_pend(char *file)
{
  char s[181], s1[181];
  int i, ok;

  sprintf(s, "%s%s", net_data, file);
  ok = 0;
  for (i = 0; i < 1000 && !ok; i++) {
    sprintf(s1, "%sP0-%u.NET", net_data, i);
    if (!exist(s1)) {
      rename(s, s1);
      ok = 1;
    }
  }
}

void check_packets(void)
{
  char s[MAXPATH], s1[MAXPATH];
  int f1;
  struct ffblk ff;

  sprintf(s, "%sP0-*.%3.3d", net_data, instance);
  f1 = findfirst(s, &ff, 0);
  while (f1 == 0) {
    if (ff.ff_fsize == 0L) {
      sprintf(s1, "%s%s", net_data, ff.ff_name);
      if (unlink(s1) != 0)
        rename_pend(ff.ff_name);
    } else
      rename_pend(ff.ff_name);
    f1 = findnext(&ff);
  }
}


void write_groups(int display)
{
  int i;
  char fn[160];
  FILE *groupfp;

  sprintf(fn, "%sNEWS.RC", net_data);

  if ((groupfp = fsh_open(fn, "wt+")) == NULL) {
    output("\n  Unable to open %s!", fn);
    return;
  } else {
    if (display)
      output("\n  Updating message pointers..");
  }
  for (i = 0; i < ngroups; i++) {
    if ((*grouprec[i].groupname) && (stricmp(grouprec[i].groupname, "newsrc") != 0)) {
      fprintf(groupfp, "%s %ld %s\n", grouprec[i].groupname,
              grouprec[i].lastread, grouprec[i].subtype);
      if ((i % 5 == 0) && (display))
        output(".");
    }
  }
  if (groupfp != NULL)
    fclose(groupfp);
}

void nntp_shutdown(Mail_Socket * NNTP_sock)
{
  if (NNTP_sock->sock != NULL) {
    sock_puts(NNTP_sock->sock, "QUIT");
    sock_close(NNTP_sock->sock);
    sock_wait_closed(NNTP_sock->sock, sock_delay, NULL, &NNTP_stat);
  }
sock_err:
  return;
}

void read_groups(void)
{
  int i = 0, ok;
  unsigned short sn;
  char *ss, fn[101], fn1[160], tmp[121];
  FILE *groupfp;

  sprintf(fn1, "%sNEWS.RC", net_data);
  ngroups = count_lines(fn1);
  if (!ngroups)
    return;
  if (grouprec != NULL)
    farfree(grouprec);
  grouprec = NULL;
  grouprec = (GROUPFILEREC *) farmalloc((ngroups + 1) * sizeof(GROUPFILEREC));
  if (!grouprec) {
    ngroups = 0;
    output("\n  Insufficient memory for %d groups in %s.", ngroups, fn1);
    return;
  }
  if ((groupfp = fsh_open(fn1, "rt")) == NULL) {
    if (grouprec != NULL)
      farfree(grouprec);
    ngroups = 0;
    return;
  }
  while (fgets(tmp, 120, groupfp)) {
    if (*tmp) {
      if (strncmpi(tmp, "newsrc", 6) == 0) {
        strcpy(grouprec[i].groupname, "newsrc");
        ++i;
      } else {
        ss = strtok(tmp, " ");
        strcpy(grouprec[i].groupname, ss);
        ss = strtok(NULL, " ");
        if (ss != NULL) {
          grouprec[i].lastread = atol(ss);
          ss = strtok(NULL, " \n");
          if (ss != NULL) {
            strcpy(grouprec[i].subtype, strupr(ss));
            ++i;
          }
        }
      }
    }
  }
  ngroups = i;
  if (groupfp != NULL)
    fclose(groupfp);
  for (i = 0; i < ngroups; i++) {
    if ((grouprec[i].subtype) && (atoi(grouprec[i].subtype) != 0)) {
      sprintf(fn, "%sN%s.NET", net_data, grouprec[i].subtype);
      if (exist(fn)) {
        ok = 0;
        if ((groupfp = fsh_open(fn, "rt")) != NULL) {
          while ((fgets(tmp, 25, groupfp)) && !ok) {
            sn = atoi(tmp);
            if (sn == 32767)
              ok = 1;
          }
          fclose(groupfp);
        }
        if (!ok)
          log_it(1, "\n  @32767 not listed as a subscriber in N%s.NET!",
                 grouprec[i].subtype);
      }
    }
  }
}

int sendauthinfo(Mail_Socket * NNTP_sock)
{
  char s[MAXPATH], buf[STR];

  *_temp_buffer = 0;

  output("\n  Server requested authentication information.");

  while (1) {
    sprintf(buf, "authinfo user %s", NEWSNAME);
    sock_printf(NNTP_sock->sock, buf);
    sock_wait_input(NNTP_sock->sock, sock_delay, NULL, &NNTP_stat);
    sock_gets(NNTP_sock->sock, _temp_buffer, sizeof(_temp_buffer));
    sscanf(_temp_buffer, "%hu %s", &reply, s);
    if (reply == 381) {
      sprintf(buf, "authinfo pass %s", NEWSPASS);
      sock_printf(NNTP_sock->sock, buf);
      sock_wait_input(NNTP_sock->sock, sock_delay, NULL, &NNTP_stat);
      sock_gets(NNTP_sock->sock, _temp_buffer, sizeof(_temp_buffer));
      sscanf(_temp_buffer, "%hu %s", &reply, s);
      if (reply == 281) {
        output("\n  Authentication accepted.  Continuing news retrieval session.");
        return 1;
      } else {
        output("\n  Authentication failed.  Aborting news retrieval session.");
        return 0;
      }
    } else {
      output("\n  Unknown AUTHINFO response %s.", _temp_buffer);
      return 0;
    }
  }
  SOCK_READ_ERR(NNTP);
  return 0;
}

int cgroup(Mail_Socket * NNTP_sock, char *s)
{
  char junk[STRING];

  *_temp_buffer = 0;

  sock_printf(NNTP_sock->sock, "GROUP %s", s);
  sock_wait_input(NNTP_sock->sock, sock_delay, NULL, &NNTP_stat);
  sock_gets(NNTP_sock->sock, _temp_buffer, sizeof(_temp_buffer));
  sscanf(_temp_buffer, "%hu %lu", &reply, &reparticle);
  switch (reply) {
    case 411:
      return 0;
    case 211:
      sscanf(_temp_buffer, "%hu %lu %lu %lu %s",
             &reply, &cur_numa, &cur_first, &cur_last, &junk);
      return 1;
    case 480:
      return (-1);
    default:
      log_it(0, "\n  Unknown cgroup response : %s", _temp_buffer);
      break;
  }
  SOCK_READ_ERR(NNTP);
  return 0;
}

void treat(char *str)
{
  char *obuf, *nbuf;

  if (*str) {
    for (obuf = str, nbuf = str; *obuf && obuf; ++obuf) {
      if (((*obuf >= 32) && (*obuf <= 126)) || (*obuf == 10) || (*obuf == 9)) {
        *nbuf++ = *obuf;
      }
    }
    *nbuf = 0;
  }
}

void name_packet(char *pktname)
{
  int ok;
  struct stat info;
  unsigned int i;

  ok = 0;
  for (i = 0; ((i < 1000) && (!ok)); i++) {
    sprintf(pktname, "%sP0-%u.%3.3d", net_data, i, instance);
    if (stat(pktname, &info) == -1)
      ok = 1;
  }
}

int savebody(Mail_Socket * NNTP_sock, char *fn, int cug, unsigned long cur_article, int *abort)
{
  int i, place, len, curpos, count, part;
  char _big_temp_buffer[BIGSTR];
  char ch, spin[26], buf[180];
  unsigned long msgsize;
  struct stat statbuf;
  FILE *tpktfp;

  place = count = 0;
  *_temp_buffer = 0;
  part = 1;

  strcpy(spin, "||//--\\\\");
  len = strlen(spin);

  sock_printf(NNTP_sock->sock, "BODY %ld", cur_article);
  sock_wait_input(NNTP_sock->sock, sock_delay, NULL, &NNTP_stat);
  sock_gets(NNTP_sock->sock, _temp_buffer, sizeof(_temp_buffer));
  sscanf(_temp_buffer, "%hu %lu", &reply, &reparticle);
  switch (reply) {
    case 423:
      return 0;
    case 222:
      if (!spooltodisk) {
        if ((tpktfp = fsh_open(fn, "wt+")) == NULL) {
          fprintf(stderr, "\n  Unable to create temporary packet 1 %s", fn);
          sock_wait_closed(NNTP_sock->sock, sock_delay, NULL, &NNTP_stat);
          *abort = 3;
          return 0;
        } else
          fputs("\n", tpktfp);
      } else {
        if (tpktfp != NULL)
          fclose(tpktfp);
        if ((tpktfp = fsh_open(fn, "at+")) == NULL) {
          fprintf(stderr, "\n  Unable to create temporary packet 2 %s", fn);
          sock_wait_closed(NNTP_sock->sock, sock_delay, NULL, &NNTP_stat);
          *abort = 3;
          return 0;
        } else {
          fputs("\n", tpktfp);
          for (i = 0; i < 79; i++)
            fputs("-", tpktfp);
          fputs("\n", tpktfp);
          sprintf(buf, "Art  : %lu\n", cur_article);
          fputs(buf, tpktfp);
          if (*cur_date)
            sprintf(buf, "Date : %s\n", cur_date);
          else
            sprintf(buf, "Date : Unknown\n");
          fputs(buf, tpktfp);
          if (*cur_replyto)
            sprintf(buf, "From : %s\n", cur_replyto);
          else
            sprintf(buf, "From : Unknown\n");
          fputs(buf, tpktfp);
          if (*cur_subject)
            sprintf(buf, "Subj : %s\n\n", cur_subject);
          else
            sprintf(buf, "Subj : Unknown\n");
          fputs(buf, tpktfp);
        }
      }
      if (!spooltodisk)
        output("\n  Receiving message - [Esc] aborts - [Space] skips group [-]");
      else
        output("\n  Appending to NEWS%d.UUE - [Esc] aborts - [Space] skips group [-]", cug);
      msgsize = 0L;
      curpos = 0L;
      if (!*abort) {
        while (1) {
          tcp_tick(NULL);
          while (kbhit()) {
            ch = (getch());
            switch (ch) {
              case 32:
                backline();
                output("\r  Skipping group... please wait until this message is completed [-]");
                *abort = 2;
                break;
              case 27:
                backline();
                output("\r  Abort detected... please wait until this message is completed [-]");
                *abort = 1;
                break;
              default:
                break;
            }
          }
          sock_wait_input(NNTP_sock->sock, sock_delay, NULL, &NNTP_stat);
          sock_gets(NNTP_sock->sock, _big_temp_buffer, sizeof(_big_temp_buffer));
          if (_big_temp_buffer[0] == '.' && _big_temp_buffer[1] == 0)
            break;
          else {
            treat(_big_temp_buffer);
            strcat(_big_temp_buffer, "\n");
            curpos = strlen(_big_temp_buffer);
            fputs(_big_temp_buffer, tpktfp);
            msgsize += curpos;
          }
          if (count++ > 5) {
            output("\b\b%c]", spin[place++]);
            if (len)
              place %= len;
            count = 0;
          }
          if ((msgsize > 30000L) && (!spooltodisk)) {
            strcpy(buf, "\nContinued in next message...\n");
            fputs(buf, tpktfp);
            if (tpktfp != NULL)
              fclose(tpktfp);
            sprintf(fn, "%sSPOOL\\INPUT%d.MSG", net_data, ++part);
            if (stat(fn, &statbuf) == 0)
              unlink(fn);
            if ((tpktfp = fsh_open(fn, "wt+")) == NULL) {
              fprintf(stderr, "\n  Unable to create temporary packet 3 %s", fn);
              sock_wait_closed(NNTP_sock->sock, sock_delay, NULL, &NNTP_stat);
              *abort = 3;
              return 0;
            }
            backline();
            output("\r  Breaking into %d%s part [ ]", (part), ordinal_text(part));
            strcpy(buf, "\nContinued from previous message...\n");
            fputs(buf, tpktfp);
            msgsize = strlen(buf);
          }
        }
        if (tpktfp != NULL)
          fclose(tpktfp);
        output("\b\bX]");
        return 1;
      }
      return 1;
    default:
      output("\n  Unknown BODY error : %s", _temp_buffer);
      break;
  }

  SOCK_READ_ERR(NNTP);
  return 0;
}

int extract(char *to, char *key, char *from)
{
  if (!strnicmp(from, key, strlen(key))) {
    from += strlen(key);
    while (*from == ' ')
      from++;
    strcpy(to, from);
    return 1;
  } else
    return 0;
}


int chead(Mail_Socket * NNTP_sock, unsigned long cur_article)
{
  char _big_temp_buffer[BIGSTR];

  *cur_path = 0;
  *cur_from = 0;
  *cur_replyto = 0;
  *cur_subject = 0;
  *cur_newsgroups = 0;
  *cur_message_ID = 0;
  *cur_references = 0;
  *cur_date = 0;
  *_temp_buffer = 0;

  sock_printf(NNTP_sock->sock, "HEAD %lu", cur_article);
  sock_wait_input(NNTP_sock->sock, sock_delay, NULL, &NNTP_stat);
  sock_gets(NNTP_sock->sock, _big_temp_buffer, sizeof(_big_temp_buffer));
  sscanf(_big_temp_buffer, "%hu %lu", &reply, &reparticle);
  switch (reply) {
    case 423:
      output("%-55.55s", "Expired article.");
      return 0;
    case 221:
      while (1) {
        sock_wait_input(NNTP_sock->sock, sock_delay, NULL, &NNTP_stat);
        sock_gets(NNTP_sock->sock, _big_temp_buffer, sizeof(_big_temp_buffer));
        if (_big_temp_buffer[0] == '.' && _big_temp_buffer[1] == 0) {
          if (cur_replyto[0] == 0)
            strcpy(cur_replyto, cur_from);
          return 1;
        }
        if ((strlen(_big_temp_buffer)) > STRING)
          _big_temp_buffer[STRING] = '\0';
        if (extract(cur_path, "Path:", _big_temp_buffer) ||
             extract(cur_from, "From:", _big_temp_buffer) ||
             extract(cur_subject, "Subject:", _big_temp_buffer) ||
             extract(cur_replyto, "Reply-To:", _big_temp_buffer) ||
             extract(cur_newsgroups, "Newsgroups:", _big_temp_buffer) ||
             extract(cur_organization, "Organization:", _big_temp_buffer) ||
             extract(cur_message_ID, "Message-ID:", _big_temp_buffer) ||
             extract(cur_references, "References:", _big_temp_buffer) ||
             extract(cur_lines, "Lines:", _big_temp_buffer) ||
             extract(cur_date, "Date:", _big_temp_buffer))
         continue;
      }
    default:
      log_it(0, "\n  Unknown chead error : %s", _big_temp_buffer);
      break;
  }
  SOCK_READ_ERR(NNTP);
  return 0;
}

Mail_Socket *netsocket(char *host)
{
  Mail_Socket *NNTP_sock = NULL;
  longword h;

  sock_init();

  if (!(h = resolve(host))) {
    if (!(h = resolve(host))) {
      output("\n  Error : Cannot resolve host %s", host);
      return NULL;
    }
  }
  if ((NNTP_sock = (Mail_Socket *) farmalloc(sizeof(Mail_Socket))) == NULL) {
    output("\n  Error: Insufficient memory to create socket... aborting.");
    return NULL;
  }
  if ((NNTP_sock->sock = (tcp_Socket *) farmalloc(sizeof(tcp_Socket))) == NULL) {
    output("\n  Error : Insufficient memory to create socket... aborting.");
    farfree(NNTP_sock);
    return NULL;
  }
  if (!tcp_open(NNTP_sock->sock, 0, h, NNTP_PORT, NULL)) {
    output("\n  Error : Unable to connect to to %s.", host);
    farfree(NNTP_sock);
    return NULL;
  }
  sock_mode(NNTP_sock->sock, TCP_MODE_ASCII);
  sock_wait_established(NNTP_sock->sock, sock_delay, NULL, &NNTP_stat);
  sock_wait_input(NNTP_sock->sock, sock_delay, NULL, &NNTP_stat);
  sock_gets(NNTP_sock->sock, _temp_buffer, sizeof(_temp_buffer));
  sscanf(_temp_buffer, "%hu %lu", &reply, &reparticle);
  switch (reply) {
    case 200:
      log_it(0, "\n  Connection to %s accepted...", host);
      return (NNTP_sock);
    case 502:
      output("\n  Connection to %s refused... try again later.", host);
      break;
    case 503:
      output("\n  NNTP service unavailable. Connection to %s refused.", host);
      break;
    default:
      output("\n  Unknown NNTP error. Connection to %s failed.", host);
      break;
  }
  SOCK_READ_ERR(NNTP);
  return 0;
}

int cnext(Mail_Socket * NNTP_sock)
{
  char *p, *q;

  *_temp_buffer = 0;

  sock_printf(NNTP_sock->sock, "NEXT");
  sock_wait_input(NNTP_sock->sock, sock_delay, NULL, &NNTP_stat);
  sock_gets(NNTP_sock->sock, _temp_buffer, sizeof(_temp_buffer));
  sscanf(_temp_buffer, "%hu %lu", &reply, &reparticle);
  switch (reply) {
    case 421:
      return 0;
    case 223:
      p = _temp_buffer;
      q = cur_articleid;
      while ((p < _temp_buffer + STRING - 2) && (*p != '<'))
        p++;
      while ((p < _temp_buffer + STRING - 2) && (*p != '>'))
        *q++ = *p++;
      *q++ = '>';
      *q++ = '\0';
      return 1;
    default:
      log_it(0, "\n  Unknown cnext error : %s", _temp_buffer);
      break;
  }
  SOCK_READ_ERR(NNTP);
  return 0;
}

int cslave(Mail_Socket * NNTP_sock)
{
  char junk[STRING];

  *_temp_buffer = 0;

  sock_printf(NNTP_sock->sock, "SLAVE");
  sock_wait_input(NNTP_sock->sock, sock_delay, NULL, &NNTP_stat);
  sock_gets(NNTP_sock->sock, _temp_buffer, sizeof(_temp_buffer));
  sscanf(_temp_buffer, "%hu %s", &reply, &junk);
  SOCK_READ_ERR(NNTP);
  return 0;
}

char *stripspace(char *str)
{
  char *obuf, *nbuf;

  if (str) {
    for (obuf = str, nbuf = str; *obuf; ++obuf) {
      if (!isspace(*obuf))
        *nbuf++ = *obuf;
    }
    *nbuf = NULL;
  }
  return (str);
}


int saveactive(Mail_Socket * NNTP_sock, int forced)
{
  char s[181], fn[MAXPATH], group[256], act;
  unsigned long to, from;
  unsigned fnday, fnmonth, fnyear, fnhour, fnminute, fnsecond;
  int f, done, update;
  unsigned long count;
  FILE *fp;
  struct ftime ft;
  struct date d;

  *_temp_buffer = 0;

  update = 0;

  sprintf(fn, "%sNEWSRC", net_data);

  f = sh_open1(fn, O_RDONLY);
  if (f < 0)
    forced = 1;
  else {
    getftime(f, &ft);
    sh_close(f);
  }

  if (!forced) {
    fnsecond = 2 * ft.ft_tsec;
    fnminute = ft.ft_min;
    fnhour = ft.ft_hour;
    fnday = ft.ft_day;
    fnmonth = ft.ft_month;
    fnyear = ft.ft_year + 80;
    output("\n  NEWSRC last updated %02u/%02u/%02u %.2u:%.2u:%.2u... ",
        fnmonth, fnday, fnyear, fnhour, fnminute, fnsecond);
    getdate(&d);
    if ((d.da_day == ft.ft_day) && (d.da_mon == ft.ft_month) &&
        (d.da_year == (ft.ft_year + 1980))) {
      output("no update required.");
      return 0;
    } else
      output("updating.");
    if ((d.da_mon == ft.ft_month) && (d.da_day != ft.ft_day))
      update = 1;
  }

  if (update)
    fp = fsh_open(fn, "a");
  else
    fp = fsh_open(fn, "w");

  if (fp == NULL) {
    perror(fn);
    return 0;
  }
  done = 0;

  while (!done) {
    if (update) {
      sprintf(s, "NEWGROUPS %02.02u%02.02u%02.02u %02.02u%02.02u%02.02u",
            fnyear, fnmonth, fnday, fnhour, fnminute, fnsecond);
      sock_printf(NNTP_sock->sock, s);
      output("\n  Refreshing NEWSRC newsgroup listing :           ");
    } else {
      sock_printf(NNTP_sock->sock, "LIST");
      output("\n  Retrieving current newsgroup listing :           ");
    }
    sock_wait_input(NNTP_sock->sock, sock_delay, NULL, &NNTP_stat);
    sock_gets(NNTP_sock->sock, _temp_buffer, sizeof(_temp_buffer));
    sscanf(_temp_buffer, "%hu %lu", &reply, &reparticle);
    if ((reply == 215) || (reply == 231)) {
      count = 0L;
      while (1) {
        sock_wait_input(NNTP_sock->sock, sock_delay, NULL, &NNTP_stat);
        sock_gets(NNTP_sock->sock, _temp_buffer, sizeof(_temp_buffer));
        if (*_temp_buffer == '.' && _temp_buffer[1] == 0)
          break;
        if (count++ % 25 == 0L)
          output("\b\b\b\b\b\b\b%-7lu", count);
        sscanf(_temp_buffer, "%s %lu %lu %c", group, &to, &from, &act);
        sprintf(s, "%s %lu\n", group, to);
        fsh_write(s, sizeof(char), strlen(s), fp);
      }
      if (update) {
        if (count == 0) {
          output("\b\b\b\b\b\b\bNo new groups.");
        } else
          output("\b\b\b\b\b\b\b%lu group%s added to NEWSRC.", count,
                count == 1 ? "" : "s");
      } else
        output("\b\b\b\b\b\b\b%lu total groups.", count);

      if (fp != NULL)
        fclose(fp);
      if (update) {
        f = sh_open1(fn, O_RDWR);
        ft.ft_day = d.da_day;
        setftime(f, &ft);
        sh_close(f);
      }
      return 1;
    } else {
      if (reply == 480) {
        if (fp != NULL)
          fclose(fp);
        return 0;
      } else {
        log_it(0, "\n  Unknown saveactive error : %s", _temp_buffer);
        if (fp != NULL)
          fclose(fp);
        done = 1;
      }
    }
  }
  SOCK_READ_ERR(NNTP);
  return 0;
}

int checkx(int cug)
{
  char *ptr, *ptr2, *ptr3, buf[256];
  int i, max;

  if ((strstr(grouprec[cug].groupname, "binaries") != NULL) && (binxpost))
    return 1;

  sprintf(buf, "%s!%s", POPNAME, POPDOMAIN);
  if (strstr(cur_path, buf) != 0) {
    sprintf(buf, "Local post - %s - skipped.", cur_subject);
    log_it(0, "%-55.55s", cur_subject);
    return 0;
  }

  ptr = cur_newsgroups;

  while (*ptr == ' ')
    ptr++;
  max = 0;
  while (1) {
    if (*ptr == 0)
      break;
    if (*ptr == ',') {
      ptr++;
      ++max;
    }
    while (*ptr == ' ')
      ptr++;
    ptr2 = ptr;
    ptr3 = buf;
    while (*ptr2 != 0 && *ptr2 != ',')
      *ptr3++ = *ptr2++;
    *ptr3 = 0;
    while (*(--ptr3) == ' ')
      *ptr3 = 0;
    ptr = ptr2;
    for (i = 0; i < cug; i++) {
      if (strcmpi(buf, grouprec[i].groupname) == 0) {
        output("Already posted in %s.", grouprec[i].groupname);
        return 0;
      }
    }
    if ((crossposts > 0) && (max > crossposts)) {
      sprintf(buf, "Crossposted to more than %hu newsgroups.", crossposts);
      output("%-55.55s", buf);
      return 0;
    }
  }
  return 1;
}

int postnews(Mail_Socket * NNTP_sock, int cug)
{
  char s[181], s1[12], s2[5], fn[201], buf[STR], *ss;
  int f1, nlines, len, tlen;
  FILE *fp;
  struct ffblk ff;

  *_temp_buffer = 0;

  sprintf(fn, "%sOUTBOUND\\%s.*", net_data, grouprec[cug].subtype);
  f1 = findfirst(fn, &ff, 0);
  if (f1 != 0) {
    log_it(0, "\n  No outbound news articles to post...");
    return 1;
  }
  while (f1 == 0) {
    sock_printf(NNTP_sock->sock, "POST");
    sock_wait_input(NNTP_sock->sock, sock_delay, NULL, &NNTP_stat);
    sock_gets(NNTP_sock->sock, _temp_buffer, sizeof(_temp_buffer));
    if (*_temp_buffer != '3') {
      if (atoi(_temp_buffer) == 440)
        log_it(1, "\n  No posting allowed to %s!", grouprec[cug].groupname);
      else
        log_it(0, "\n  Remote error: %s", _temp_buffer);
      return 0;
    }
    output("\n  Posting article to %s\n", grouprec[cug].groupname);
    sprintf(s, "%sOUTBOUND\\%s", net_data, ff.ff_name);
    fp = fsh_open(s, "rb");
    nlines = 0;
    while (fgets(buf, 120, fp) != NULL) {
      if (*buf == '.' && buf[1] == 0) {
        buf[1] = '.';
        buf[2] = 0;
      }
      tlen = 0;
      len = strlen(buf);
      while (tlen < len) {
        if (!tcp_tick(NNTP_sock->sock)) {
          if (fp != NULL)
            fclose(fp);
          output("\n  Connection reset by host");
          return 1;
        }
        tlen += sock_fastwrite(NNTP_sock->sock, &buf[tlen], len - tlen);
      }
      backline();
      output("\r  Lines sent : %d", ++nlines);
    }
    if (fp != NULL)
      fclose(fp);
    sock_printf(NNTP_sock->sock, ".\n");
    output("\n  Awaiting acknowledgement - may take several minutes...");
    log_it(0, "\n  Server response : ");
    sock_wait_input(NNTP_sock->sock, 180, NULL, &NNTP_stat);
    sock_gets(NNTP_sock->sock, _temp_buffer, sizeof(_temp_buffer));
    log_it(0, "%s", _temp_buffer);
    if (*_temp_buffer != '2') {
      sscanf(_temp_buffer, "%hu %s", &reply, &buf);
      if (reply == 441) {
        ss = strtok(_temp_buffer, " ");
        ss = strtok(NULL, " ");
        if (atoi(ss) == 435)
          unlink(s);
        fnsplit(s, NULL, NULL, s1, s2);
        log_it(0, "\n  %s%s not accepted by server - nothing posted", s1, s2);
        if (unlink(s) == 0)
          log_it(0, "\n  Deleted message - %s", s);
      } else
        log_it(0, "\n  Remote error: %s", _temp_buffer);
    } else {
      if (unlink(s) == 0)
        log_it(0, "\n  Deleted sent message - %s", s);
    }
    f1 = findnext(&ff);
  }
  SOCK_READ_ERR(NNTP);
  return 0;
}

void get_subtype(int sub, char *where)
{
  int ok, which;
  char fn[181], s[81], net_name[21], *ss;
  FILE *fp;

  where[0] = 0;
  which = sub;
  sprintf(fn, "%sSUBS.XTR", syscfg.datadir);
  if ((fp = fsh_open(fn, "r")) == NULL)
    return;
  ok = 0;
  while (fgets(s, 80, fp)) {
    if (*s == '!') {
      if (which == atoi(&s[1]))
        ok = 1;
    }
    if (ok && (*s == '$')) {
      ss = strtok(s, " ");
      strcpy(net_name, &ss[1]);
      ss = strtok(NULL, " ");
      if (fp != NULL)
        fclose(fp);
      if ((stricmp(net_name, "FILENET") == 0)) {
        trimstr1(ss);
        strcpy(where, ss);
        return;
      } else
        return;
    }
  }
  if (fp != NULL)
    fclose(fp);
}

unsigned long max_on_sub(int cug)
{
  int i, num_subs;
  char fn[MAXPATH], subtype[12];
  unsigned long max;
  subboardrec sub;
  FILE *fp;

  max = 0;
  if ((strlen(grouprec[cug].subtype) == 1) && (*grouprec[cug].subtype == '0'))
    return max;
  output("\n  Maximum posts -     ");
  sprintf(fn, "%sSUBS.DAT", syscfg.datadir);
  if ((fp = fsh_open(fn, "rb")) == NULL) {
    output("\n  Unable to read %s.", fn);
    return max;
  } else {
    fseek(fp, 0L, SEEK_END);
    num_subs = (int) (ftell(fp) / sizeof(subboardrec));
    for (i = 0; i < num_subs; i++) {
      output("\b\b\b\b%-4d", i);
      fseek(fp, (long) i * sizeof(subboardrec), SEEK_SET);
      fread(&sub, sizeof(subboardrec), 1, fp);
      get_subtype(i, subtype);
      if (stricmp(subtype, grouprec[cug].subtype) == 0) {
        max = (unsigned long)sub.maxmsgs;
        output("\b\b\b\b%s (%s) - %lu posts.", sub.name, subtype, max);
        break;
      }
    }
  }
  if (fp != NULL)
    fclose(fp);
  return max;
}


int getnews(Mail_Socket * NNTP_sock)
{
  int f1, nup, nug, cug, abort, ok, done, firstrun, parts, skipped, bogus;
  char *p, fn[MAXPATH], mailname[121], reline[121], pktname[121];
  char ch, orig_subj[STRING], buf[STR];
  unsigned int text_len;
  unsigned short temptype;
  unsigned long new_articles, max_articles;
  net_header_rec nh;
  struct stat statbuf;
  struct ffblk ff;
  FILE *fp;

  abort = cug = bogus = 0;
  fp = NULL;

  if (stricmp(grouprec[0].groupname, "newsrc") == 0) {
    if (!saveactive(NNTP_sock, 1)) {
      if (sendauthinfo(NNTP_sock))
        saveactive(NNTP_sock, 1);
    }
  } else
    saveactive(NNTP_sock, 0);

  nug = nup = 1;
  skipped = 0;
  cslave(NNTP_sock);
  while ((cug < ngroups) && (!abort)) {
    tcp_tick(NNTP_sock->sock);
    if (nup) {
      nup = 0;
      if (grouprec[cug].subtype) {
        if (fp != NULL)
          fclose(fp);
        name_packet(pktname);
        if ((fp = fsh_open(pktname, "wb")) == NULL) {
          log_it(0, "\n  Unable to create %s!", pktname);
          return 1;
        }
      } else {
        if (fp != NULL)
          fclose(fp);
      }
      write_groups(1);
    }
    if (nug) {
      nug = 0;
      while (1) {
        if (!cgroup(NNTP_sock, grouprec[cug].groupname)) {
          if (cgroup(NNTP_sock, grouprec[cug].groupname) == -1) {
            if (sendauthinfo(NNTP_sock))
              continue;
            else
              return 1;
          }
          if (++bogus > 10) {
            log_it(0, "\n  Too many invalid newsgroups... NEWS.RC error!");
            return 1;
          }
          log_it(1, "\n  Error accessing newsgroup \"%s\".", grouprec[cug].groupname);
          nug = 1;
          break;
        } else
          break;
      }
      if (!nug) {
        log_it(0, "\n  Requesting %s... ", grouprec[cug].groupname);
        if (grouprec[cug].lastread < cur_first)
          grouprec[cug].lastread = cur_first;
        if (grouprec[cug].lastread >= cur_last) {
          grouprec[cug].lastread = cur_last;
          log_it(0, "no new articles.");
          nug = 1;
        } else {
          new_articles = cur_last - grouprec[cug].lastread;
          if (new_articles) {
            log_it(0, "%lu new article%s.", new_articles,
                   new_articles == 1 ? "" : "s");
          } else {
            log_it(0, "no new articles.");
            nug = 1;
          }
          if (new_articles > 250L) {
            max_articles = max_on_sub(cug);
            if (max_articles && (new_articles > max_articles)) {
              log_it(0, "\n  Requesting most recent %lu articles", max_articles);
              grouprec[cug].lastread = cur_last - max_articles;
            }
          } else
            ++grouprec[cug].lastread;
        }
        postnews(NNTP_sock, cug);
        if (!nug) {
          if (cur_numa == 0) {
            log_it(0, "\n  No articles in %s...", grouprec[cug].groupname);
            nug = 1;
            continue;
          }
        }
      }
    } else {
      if ((!cnext(NNTP_sock)) || (grouprec[cug].lastread > cur_last)) {
        output("\n  End of articles in %s", grouprec[cug].groupname);
        nug = 1;
        write_groups(1);
      }
    }
    while (kbhit()) {
      ch = (getch());
      switch (ch) {
        case 27:
          log_it(0, "\n  Aborting news retrieval session...");
          abort = 1;
          break;
        case 32:
          output("\n  Skipping group %s... ", grouprec[cug].groupname);
          nug = 1;
          break;
        default:
          break;
      }
    }
    if (!nug) {
      if (skipped)
        output("\r");
      else
        output("\n");
      output("  [%lu/%lu] : ", grouprec[cug].lastread, cur_last);
      if ((chead(NNTP_sock, grouprec[cug].lastread)) && (checkx(cug))) {
        skipped = 0;
        if (*cur_subject)
          treat(cur_subject);
        else
          strcpy(cur_subject, "No subject");
        strcpy(orig_subj, cur_subject);
        if (*cur_from) {
          treat(cur_from);
          if (strlen(cur_from) > 45)
            cur_from[45] = 0;
        } else
          strcpy(cur_from, "Unknown");
        if (*cur_replyto) {
          if (strlen(cur_replyto) > 45)
            cur_replyto[45] = 0;
        } else
          strcpy(cur_replyto, "Unknown");
        output("%-55.55s", orig_subj);
        if ((strlen(grouprec[cug].subtype) == 1) && (grouprec[cug].subtype[0] == '0')) {
          spooltodisk = 1;
          sprintf(fn, "%sSPOOL\\NEWS%d.UUE", net_data, cug);
        } else {
          spooltodisk = 0;
          sprintf(fn, "%sSPOOL\\INPUT1.MSG", net_data);
          if (stat(fn, &statbuf) == 0)
            unlink(fn);
        }
        abort = 0;
        ok = (savebody(NNTP_sock, fn, cug, grouprec[cug].lastread, &abort));
        if (ok && grouprec[cug].subtype) {
          sprintf(fn, "%sSPOOL\\INPUT*.MSG", net_data);
          done = 1;
          parts = 0;
          if (findfirst(fn, &ff, 0) == 0) {
            parts = 1;
            done = 0;
          }
          firstrun = 1;
          while (!done) {
            sprintf(fn, "%sSPOOL\\%s", net_data, ff.ff_name);
            f1 = sh_open1(fn, O_RDONLY | O_BINARY);
            text_len = (unsigned int) filelength(f1);
            if (text_len > 32000L) {
              output("\n  Truncating %lu bytes from input file",
                     text_len - 32000L);
              text_len = 32000L;
            }
            if ((p = (char *) malloc(32767L)) == NULL) {
              log_it(0, "\n  Insufficient memory to read entire message");
              return 1;
            }
            sh_read(f1, (void *) p, text_len);
            sh_close(f1);
            temptype = atoi(grouprec[cug].subtype);
            nh.tosys = sy;
            nh.touser = 0;
            nh.fromsys = 32767;
            nh.fromuser = 0;
            if (!temptype) {
              nh.main_type = main_type_new_post;
              nh.minor_type = 0;
            } else {
              nh.main_type = main_type_pre_post;
              nh.minor_type = temptype;
            }
            nh.list_len = 0;
            ++cur_daten;
            nh.daten = cur_daten;
            nh.method = 0;
            if (parts > 1) {
              sprintf(buf, "%d%s ", parts, ordinal_text(parts));
              strncat(buf, orig_subj, 72);
              strcpy(cur_subject, buf);
              cur_subject[72] = '\0';
            }
            nh.length = text_len + strlen(cur_subject) + 1;
            strncpy(mailname, cur_replyto, 46);
            strcat(mailname, "\r\n");
            nh.length += strlen(mailname);
            if (nh.main_type == main_type_new_post)
              nh.length += strlen(grouprec[cug].subtype) + 1;
            if (firstrun) {
              firstrun = 0;
              if (strncmpi(cur_articleid, "re: ", 4) == 0) {
                strncpy(reline, cur_articleid, 60);
                sprintf(cur_articleid, "Re: %s\r\n\r\n", reline);
              }
            }
            if (!*cur_date) {
              strncpy(cur_date, ctime(&(time_t) nh.daten), 24);
              cur_date[24] = '\0';
            }
            strcat(cur_date, "\r\n");
            nh.length += strlen(cur_date);
            nh.length += strlen(cur_articleid);
            fsh_write(&nh, sizeof(net_header_rec), 1, fp);
            if (nh.main_type == main_type_new_post)
              fsh_write(grouprec[cug].subtype, sizeof(char), strlen(grouprec[cug].subtype) +1, fp);
            fsh_write(cur_subject, sizeof(char), strlen(cur_subject) +1, fp);
            fsh_write(mailname, sizeof(char), strlen(mailname), fp);
            fsh_write(cur_date, sizeof(char), strlen(cur_date), fp);
            fsh_write(cur_articleid, sizeof(char), strlen(cur_articleid), fp);
            fsh_write(p, sizeof(char), text_len, fp);
            if (p)
              free(p);
            unlink(fn);
            if (findnext(&ff) == 0) {
              done = 0;
              ++parts;
            } else
              done = 1;
          }
        }
      } else
        skipped = 1;
      ++grouprec[cug].lastread;
      if ((filelength(fileno(fp)) > 250000L) && grouprec[cug].subtype)
        nup = 1;
      if (abort == 2) {
        write_groups(1);
        nug = 1;
        abort = 0;
      }
      if (abort == 3) {
        output("\n  Disk error - exiting.");
        write_groups(1);
        return 1;
      }
    }
    if (nug) {
      ++cug;
      if (((strlen(grouprec[cug].subtype) == 1) &&
           (grouprec[cug].subtype[0] == '0')) && (grouprec[cug].subtype)) {
        nup = 1;
      } else {
        if (((strlen(grouprec[cug - 1].subtype)) > 1) &&
            ((strlen(grouprec[cug].subtype) == 1) &&
             (grouprec[cug].subtype[0] == '0'))) {
          if (fp != NULL)
            fclose(fp);
        }
      }
    }
  }
  if (fp != NULL)
    fclose(fp);
  nntp_shutdown(NNTP_sock);
  if (abort)
    log_it(0, "\n  Session aborted from keyboard");
  return 0;
}

int copyfile(char *input, char *output)
{
  int f1, f2, i;
  char *b;
  struct ftime ft;

  if ((strcmp(input, output) != 0) && (exist(input)) && (!exist(output))) {
    if ((b = (char *) malloc(16400)) == NULL)
      return 0;
    f1 = sh_open1(input, O_RDONLY | O_BINARY);
    if (!f1) {
      free(b);
      b = NULL;
      return 0;
    }
    getftime(f1, &ft);

    f2 = sh_open(output, O_RDWR | O_BINARY | O_CREAT | O_TRUNC, S_IREAD | S_IWRITE);
    if (!f2) {
      free(b);
      b = NULL;
      f1 = sh_close(f1);
      return 0;
    }
    i = read(f1, (void *) b, 16384);
    while (i > 0) {
      sh_write(f2, (void *) b, i);
      i = read(f1, (void *) b, 16384);
    }
    f1 = sh_close(f1);
    setftime(f2, &ft);
    f2 = sh_close(f2);
    free(b);
    b = NULL;
  }
  return 1;
}



main(int argc, char *argv[])
{
  int ok, f, bAuth;
  char s[160], fn[MAXPATH], tempfn[MAXPATH], *ss;
  FILE *fp;
  struct tm *time_now;
  struct date dt;
  struct time tm;
  time_t some;
  Mail_Socket *nntp_sock = NULL;

  crossposts = 10;
  binxpost = 0;
  POPNAME[0] = 0;
  POPDOMAIN[0] = 0;

  cursor('S');
  cursor('H');
  output("\n  %s", version);
  if (argc != 4) {
    output("\n  Invalid arguments for %s\n", argv[0]);
    cursor('R');
    return EXIT_FAILURE;
  }
  strcpy(net_data, argv[1]);
  strcat(net_data, "\\");
  strcpy(serverhost, argv[2]);
  sy = atoi(argv[3]);

  get_dir(maindir, 0);

  detect_multitask();

  gettime(&tm);
  getdate(&dt);
  cur_daten = dostounix(&dt, &tm);
  time(&some);
  time_now = localtime(&some);
  strftime(s, 80, "\n\nNEWS session beginning on %A, %B %d, %Y at %H:%M %p",
           time_now);
  sprintf(fn, "%sNEWS.LOG", net_data);
  if ((fp = fsh_open(fn, "at")) != NULL) {
    fprintf(fp, s);
    fclose(fp);
  }
  ss = getenv("WWIV_INSTANCE");
  if (ss) {
    instance = atoi(ss);
    if ((instance <= 0) || (instance >= 1000)) {
      log_it(0, "\n  WWIV_INSTANCE set to %d.  Can only be 1..999!", instance);
      instance = 1;
    }
  } else
    instance = 1;

  sprintf(fn, "%s\\CONFIG.DAT", maindir);
  f = sh_open1(fn, O_RDONLY | O_BINARY);
  if (f < 0) {
    output("\n  %s NOT FOUND.", fn);
    return EXIT_FAILURE;
  }
  sh_read(f, (void *) (&syscfg), sizeof(configrec));
  sh_close(f);

  read_groups();
  if (ngroups == 0) {
    output("\n  Unable to access newsgroup file NEWS.RC!");
    return EXIT_FAILURE;
  } else {
    sprintf(fn, "%sNEWS.RC", net_data);
    sprintf(tempfn, "%sNEWS.BAK", net_data);
    if (exist(tempfn))
      unlink(tempfn);
    copyfile(fn, tempfn);
  }

  if (stricmp(grouprec[0].groupname, "newsrc") == 0)
    log_it(0, "\n  Retrieving current newsgroup listing from %s.",
           serverhost);
  else
    log_it(0, "\n  %u newsgroup%s defined in NEWS.RC.", ngroups,
           ngroups == 1 ? "" : "s");

  sprintf(fn, "%s\\NET.INI", maindir);
  if ((fp = fsh_open(fn, "rt")) == NULL)
    output("\n  Unable to read %s", fn);
  else {
    while (fgets(s, 100, fp)) {
      stripspace(s);
      if ((*s == ';') || (*s == '\n') || (*s == '['))
        continue;
      if (strlen(s) == 0)
        continue;
      if ((strnicmp(s, "POPNAME", 7) == 0) && (POPNAME[0] == 0)) {
        ss = strtok(s, "=");
        if (ss) {
          ss = strtok(NULL, "\n");
          trimstr1(ss);
          strcpy(POPNAME, ss);
        }
      }
      if (strnicmp(s, "FWDNAME", 7) == 0) {
        ss = strtok(s, "=");
        if (ss) {
          ss = strtok(NULL, "\n");
          trimstr1(ss);
          strcpy(POPNAME, ss);
        }
      }
      if ((strnicmp(s, "DOMAIN", 6) == 0) && (POPDOMAIN[0] == 0)) {
        ss = strtok(s, "=");
        if (ss) {
          ss = strtok(NULL, "\n");
          trimstr1(ss);
          strcpy(POPDOMAIN, ss);
        }
      }
      if (strnicmp(s, "FWDDOM", 6) == 0) {
        ss = strtok(s, "=");
        if (ss) {
          ss = strtok(NULL, "\n");
          trimstr1(ss);
          strcpy(POPDOMAIN, ss);
        }
      }
      if (strnicmp(s, "XPOSTS", 6) == 0) {
        ss = strtok(s, "=");
        if (ss) {
          ss = strtok(NULL, "\n");
          trimstr1(ss);
          crossposts = atoi(ss);
          if (crossposts > 99)
            crossposts = 10;
        }
      }
      if (strnicmp(s, "BINXPOST", 9) == 0) {
        ss = strtok(s, "=");
        if (ss) {
          binxpost = 0;
          ss = strtok(NULL, "\n");
          trimstr1(ss);
          if ((ss[0] == 'y') || (ss[0] == 'Y'))
            binxpost = 1;
        }
      }
      if (strnicmp(s, "NEWSNAME", 8) == 0) {
        ss = strtok(s, "=");
        if (ss) {
          ss = strtok(NULL, "\n");
          trimstr1(ss);
          strcpy(NEWSNAME, ss);
        }
      }
      if (strnicmp(s, "NEWSPASS", 8) == 0) {
        ss = strtok(s, "=");
        if (ss) {
          ss = strtok(NULL, "\n");
          trimstr1(ss);
          strcpy(NEWSPASS, ss);
        }
      }
      ss = NULL;
    }
    if (fp != NULL)
      fclose(fp);
  }
  ok = 1;
  if ((nntp_sock = netsocket(serverhost)) != NULL) {
    bAuth = 1;
    if (NEWSNAME[0]) {
      if (!sendauthinfo(nntp_sock))
        bAuth = 0;
    }
    if (bAuth)
      ok = getnews(nntp_sock);
    if (ok)
      log_it(1, "\n  NEWS exited with an error.");
    else
      log_it(0, "\n  Normal NEWS completion.");
  }
  cd_to(maindir);
  log_it(0, "\n  NEWS completed processing %d newsgroups", ngroups);
  if (grouprec)
    farfree(grouprec);
  grouprec = NULL;
  check_packets();
  trim_log();
  free_Mail_Socket(nntp_sock);
  fcloseall();
  cursor('R');
  return ok;
}
